﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MapApp.Model;

namespace MapApp.Ui.Controls
{
    public partial class FrmInfo : AppFormBase
    {

        public FrmInfo()
        {
            InitializeComponent();
            CustomInitialize();
        }

        private void CustomInitialize()
        {
            FrmMain.Instance.MapControl.MapClick += new MapApp.Ui.Controls.GoogleMapControl.OnMapClick(MapControl_MapClick);
            FrmMain.Instance.MapControl.MapMouseMove += new MapApp.Ui.Controls.GoogleMapControl.OnMapMouseMove(MapControl_MapMouseMove);
        }

        void MapControl_MapMouseMove(MapApp.Ui.Controls.GoogleMapControl sender, MapApp.Model.MapLocation loc)
        {
            txtMouseLocationLatitude.Text = "" + loc.Lat;
            txtMouseLocationLongitude.Text = "" + loc.Lng;
            txtMouseLocationZoomLevel.Text = "" + loc.ZoomLevel;
        }

        void MapControl_MapClick(MapApp.Ui.Controls.GoogleMapControl sender, MapApp.Ui.Controls.MapClickEventArgs e)
        {
            MapLocation loc = e.MapLocation;
            txtClickLocationLatitude.Text = "" + loc.Lat;
            txtClickLocationLongitude.Text = "" + loc.Lng;
            txtClickLocationZoomLevel.Text = "" + loc.ZoomLevel;
        }

        private void btnDone_Click(object sender, EventArgs e)
        {
            this.Hide();
        }
    }
}
